<?php
/**
 * User: ArturMarcos
 * Date: 25/08/18
 * Time: 11:20
 * To change this template use File | Settings | File Templates.
 */

namespace HCM\Geral\Logic\Apolo;

use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\Util;
use HCM\Util\DateUtil;
use HCM\Util\Messages;
use HCM\Util\Mail\Mail;
use HCM\Util\MsgCalculo;
use HCM\Util\Repositories;
use HCM\Util\HCMParameters;
use Teknisa\Libs\Util\SMTP;
use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Geral\Logic\ESocialLogic;
use Zeedhi\Framework\Session\Session;
use HCM\Geral\Services\ESocialService;
use HCM\Geral\Services\EnviarEmailService;

class ConsultaEsocialSimplificado {

    // Parametros de Rotas
    const IDTRANSMISSAO = 'idTransmissao';

    // Operações do eSocial
    const IDTRANSENVIO = 'ENVIAR'; //Enviar Evento
    const IDTRANSCONSU = 'CONSULTAR'; //Consultar Status do evento
    const IDTRANSREENV = 'REENVIAR'; //Reenviar Evento
    const IDTRANSEXCLU = 'EXCLUSAO'; //Excluir Evento
    
    private $hcmParameters;
    private $jenkins;
    private $entityManager;
    private $eSocialService;
    private $orgsEnvio = array();
    private $msg = array();
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ESocialService $eSocialService){
        
        $this->entityManager = \Setforms2\Shared\Registry::getEntityManager();
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->eSocialService = $eSocialService;
        $this->jenkins = true;
        $this->envioCadastros = Repositories::ESO_ENVIOCADASTROS;
    }
    
    public function startaConsulta($parametros){
        
        set_time_limit(0);
        ini_set('memory_limit', '2048M');
        error_reporting(E_ERROR | E_PARSE);
        
        foreach ($parametros as $parametro) {
            $eventos = $this->entityManager->getRepository(Repositories::ESO_EVENTO)->getEventosESocial($parametro['DSVERSAO']);
                
            foreach ($eventos as $evento) {
                $row = array_merge($evento, $parametro);
                $this->consultaAutomaticaEventos($row);
            }
        }
        if($this->msg){
            $this->notificaConsulta();
        }
    }
    
    public function consultaAutomaticaEventos($row) {
        try {
            
            $oldmask = umask(0);

            $arrEnvios = array();

            $nrEstruturam = $row['NRESTRUTURAM'];
            $nmEstruturam = $row['NMESTRUTURAM'];
            $nrEvento = $row['NREVENTO'];
            $nmEvento = $row['NMEVENTO'];
            $idGrupo = $row['IDGRUPO'];
            $idStatus = array("M", "R");
            $dtmescompetenc = $this->hcmParameters->getDtcompetencia();

            $logic = new ESocialLogic($this->entityManager, $this->hcmParameters, $row['NRESTRUTURAM'], $row['NRTPAMBIENTE'], true);

            try {
                if ($row['IDGRUPO'] == 'I' || $row['IDGRUPO'] == 'C') {
                    $msgRetorno = $logic->consultaAutomaticaCadastro($row['NMEVENTO'], $idStatus);
                }
                if ($row['IDGRUPO'] == 'N') {
                    $msgRetorno = $logic->consultaAutomaticaNaoPeriodico($row['NMEVENTO'], $idStatus);
                }
                if ($row['IDGRUPO'] == 'P') {
                    $msgRetorno = $logic->consultaAutomaticaPeriodico($row['NMEVENTO'], $idStatus);
                }
            } catch (\Exception $e) {
                echo $nmEstruturam.' - '.$nmEvento.' - '.$e->getMessage().PHP_EOL;
                //throw $e;
            }

            $msgValidacao = $logic->getMessages();

            foreach ($logic->getRetornoConsultaAutomatica() as $nrProtocolo => $envios) {
                try {
                    if($envios){
                        $this->msg[$nmEstruturam]['PARAMETRO'] = $row;
                        
                        $nmEve = $row['DSEVENTO'];
                        if(!isset($this->msg[$nmEstruturam][$nmEve])){
                            $this->msg[$nmEstruturam][$nmEve] = '<b>'.$msgRetorno.'</b>';
                        }
                    
                        foreach($envios as $envio){
                            
                            $operacao = '';
                            $tabela = '';
                            if($envio->getIdoperacao() == 'I'){
                                $operacao = 'Inclusão';
                            }else if($envio->getIdoperacao() == 'A'){
                                $operacao = 'Alteração';
                            }else if($envio->getIdoperacao() == 'E'){
                                $operacao = 'Exclusão';
                            }
                            
                            $espaco = '<span>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</span>';

                            if($envio->getNrtabela()){
                                $tabela = '     <b>Tabela:</b> '.$envio->getNrtabela().$espaco;
                            }

                            $this->msg[$nmEstruturam][$nmEve] .= 
                                '<br><br><b>Chave: '.$envio->getNrchave().'</b><br>'.
                                '<b>Nr Envio:</b> '.$envio->getNrenvio().$espaco.
                                '<b>Operação:</b> '.$operacao.$espaco.
                                '<b>Histórico:</b> '.$envio->getDtmescompetenc()->format('d/m/Y').$espaco.
                                $tabela.
                                '<b>Protocolo:</b> '.$nrProtocolo.
                                '<br>'.$envio->getDsobservacao();
                        }
                    }
                    
                    echo 'Org: '.$row['NRORG'].' - Estrutura: '.$nmEstruturam.' - Evento: '.$nmEvento.' - Consulta de lotes protocolo '.$nrProtocolo.' ('.count($envios).' erros)'.PHP_EOL;
                    
                } catch(\Exception $e) {
                    throw $e;
                }
            }
            umask($oldmask);
        } catch(\Exception $e) {
            echo 'Org: '.$row['NRORG'].' - Estrutura: '.$nmEstruturam.' - Evento: '.$nmEvento.' - Consulta de lotes ('.count($arrEnvios).' envios)'.PHP_EOL;
            echo $nmEstruturam.' - '.$e->getMessage().PHP_EOL;
            return;
        }
    }
    
    public function notificaConsulta(){
        
        foreach($this->msg as $estrutura => $eventos){
           
            $parametro = $eventos['PARAMETRO'];
            unset($eventos['PARAMETRO']);
            
            foreach($eventos as $evento => $msg){
                
                $mensagem = '';
                $mensagemEvento = '';
                $dataAtual = DateUtil::getDataAtual()->format('d/m/Y H:i:s');
                $corpo_msg = '';
                $estruturam = null;
            
                $tpAmbiente = '';
                if($parametro['NRTPAMBIENTE'] == 1){
                    $tpAmbiente = 'Produção';
                }else if($parametro['NRTPAMBIENTE'] == 2){
                    $tpAmbiente = 'Produção restrita';
                }
                
                $mensagem = "
                <br><br><b>Versão:</b> ". $parametro['DSVERSAO']."
                <br><b>Ambiente:</b> ".$tpAmbiente."
                <br><b>Eventos:</b> <br><br>";
                
                foreach($eventos as $evento => $msg){
                    if(array_key_exists($msg, $this->eSocialService->arrayMensagens)){
                        $msg = $this->eSocialService->arrayMensagens[$msg];
                    }
                    $mensagemEvento .= "<b>$evento <br><br>
                    </b> $msg <br><br>";
                }
                
                $corpo_msg .= $mensagem.$mensagemEvento;
                $mensagem = '';
                $mensagemEvento = '';
            }
                
            $assunto  = "Rotina Automática do e-Social Simplificado - Consulta - $dataAtual - $estrutura";
            
            $mail = $this->hcmParameters->returnParamsSmtp(true);
            
            $emails = explode(';', $parametro['DSEMAILENVIO']);
            foreach ($emails as $email) {
                //verifica se ja foi mandado email para o mesmo email a ser enviado.
                $nome = explode('@',$email)[0];
            
                $content = array(
                    "SUBJECT"                 => $assunto,
                    "STRING_SUPERIOR_DIREITA" => "",
                    "CONTENT_BODY"            => $corpo_msg
                );
                
                $content = $this->template($corpo_msg);
                
                $de = 'Consulta Automatica E-social Simplificado';
                $mail->newEmail(
                    $email,   //De/From
                    $content, //texto
                    $assunto, //assunto    
                    $nome,    //nome operador
                    $de,      //nome from
                    $email    //from
                );
                        
            }
        }
    }
    
    public function template($corpo_msg){
       
       $corpo = <<<HTML
<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee"> 
    <tbody> 
        <tr> 
            <td> 
                <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" style="background-color: #0274ba ; text-align: center"> 
                    <tbody> 
                        <tr> 
                            <td> 
                                <table border="0" align="center" width="540" cellpadding="0" cellspacing="0"> 
                                    <tbody> 
                                        <tr> 
                                            <td align="center" valign="middle"> 
                                                <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse: collapse"> 
                                                    <tbody> 
                                                        <tr> 
                                                            <td align="center" valign="middle"> 
                                                                <div style="color: #ffffff ; font-size: 25px ; padding: 35px ; font-family: &quot;verdana&quot; , sans-serif ; line-height: 24px">NOTIFICAÇÃO DO ESOCIAL
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                                <div style="color: #ffffff ; font-size: 16px ; font-family: &quot;verdana&quot; , sans-serif">
                                                                </div> 
                                                            </td> 
                                                        </tr> 
                                                    </tbody> 
                                                </table> 
                                            </td> 
                                        </tr> 
                                    </tbody> 
                                </table> 
                            </td> 
                        </tr> 
                    </tbody> 
                </table> 
            </td> 
        </tr> 
    </tbody> 
</table> 
<div> 
$corpo_msg
</b> 
</div> 
<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> 
    <tbody> 
        <tr> 
            <td align="center"> 
                <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff">
                    <div> 
                        <tbody> 
                            <tr> 
                                <td> 
                                    <table border="0" align="center" width="540" cellpadding="0" cellspacing="0"> 
                                        <tbody> 
                                            <tr> 
                                                <td align="left" style="color: #39434b ; font-size: 20px ; font-family: &quot;verdana&quot; , sans-serif">  
                                                    
                                                        <div>
                                                            <img src="https://www.teknisa.com/emails/img/rodape_3.png">
                                                              </div>
                                                                    </div> 
                                                                </td> 
                                                            </tr> 
                                                            <tr> 
                                                                <td height="10" style="font-size: 10px ; line-height: 10px"> 
                                                                </td> 
                                                            </tr> 
                                                        </tbody> 
                                                    </table> 
                                                </td> 
                                            </tr> 
                                        </tbody> 
                                    </div>
                                    <div>
                                        <br>
                                        </div>
                                    </table> 
                                </td> 
                            </tr> 
                        </tbody> 
                    </table> 
                    <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> 
                        <tbody> 
                            <tr> 
                                <td> 
                                    <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="#d8d8d8"> 
                                        <tbody> 
                                            <tr>
                                            </tr> 
                                            <tr>
                                            </tr> 
                                            <tr> 
                                                <td height="20" style="font-size: 20px ; line-height: 20px ; display: table"> 
                                                </td> 
                                            </tr> 
                                        </tbody> 
                                    </table> 
                                </td> 
                            </tr> 
                        </tbody> 
                    </table>
HTML;
    
        return $corpo;
    }
    
    public function setParametrosHcm($nrorg){
        
        $nrtpestrutlegal = 1;
        $nrtpestrutgeren = 6;
        $paramOrg = $this->entityManager->getRepository(Repositories::GPE_PARAMORG)->findOneBy(array('nrorg' => $nrorg));
        
        if($paramOrg){
            $nrtpestrutlegal = $paramOrg->getNrtpestrutlegal();
            $nrtpestrutgeren = $paramOrg->getNrtpestrutgeren();
        }
        
        $paramsHCM = array(
            "cdoperador"        => 1,
            "nmoperador"        => null,
            "nrestruttrab"      => null,
            "nrorgpadrao"       => 0,
            "nrorg"             => $nrorg,
            "nrorgtrab"         => $nrorg,
            "dtmescompetenc"    => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
            "dtmescompetencdiacorrente" => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
            "nrtipoestrutlegal" => $nrtpestrutlegal,
            "nrtipoestrutgeren" => $nrtpestrutgeren,
            "idambientesal"     => 'REAL',
            "nrocorrecal"       => 1,
            "nrtpmodalidcal"    => 1,
            "nrtpmodalidsal"    => 1,
            "dataatual"         => DateUtil::getDataAtual(),
            "dtultimodiames"    => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
            "dtultimodiacompetencia" => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
        );
        
        foreach ($paramsHCM as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }
    
}