<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class RelatoriosHcmService {
    
	const RPT_PONTO_DEMONSTRATIVO = 'ponto_demonstrativo';

    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
       
    public function rulesReports($parameters) {
        $nmReport = $parameters["P_NMREPORT"];

        switch ($nmReport) {
            case self::RPT_PONTO_DEMONSTRATIVO:
                return $this->rulesPontoDemonstrativo($parameters);
                break;
            
            default:
                return true;
                break;
        }
    }

    public function replaceMnemonicos($dsmensagem, $replaceMnemonico) {
        return strtr($dsmensagem, $replaceMnemonico);
    }

    private function rulesPontoDemonstrativo($parameters) {
    	$vinculo = $parameters["P_VINCULO"];
    	$nrorg   = $parameters["P_NRORG"];

    	// verifica parâmetro de controle de jornada da escala
    	$escala = \Folha\Entities\GpeEscalatrabh::getObjectsByWhere("NRESCALATRABM = ? AND NRORG = ? AND DTMESCOMPETENC <= ?", 
    	array($vinculo->historico->getNrescalatrabm(), $nrorg, $this->hcmParameters->getDtCompetencia()), "DTMESCOMPETENC ASC");
    	if (end($escala)->getIdnaocontrolajornada() == 'S')
			return false;

    	return true;
    	
    }
}