<?php
namespace Geral\Repositories;

class Formpgto extends \Doctrine\ORM\EntityRepository
{

    public function consultaFormaPagamentoEntrada($cdfilial, $nrlanctonf, $idorigdestnf, $dtentrsaid)
    {
        $sql = <<<SQl
            SELECT DECODE(DTATUAVENPAG, NULL, CONSULTA_FORMPGTO(:P_CDFILIAL, :P_NRLANCTONF, :P_IDORIGDESTNF),
                   DECODE(TO_DATE(MAX(DTATUAVENPAG)) - TO_DATE(:P_DTENTRSAID),0,0,1)) AS IDFORMPGTSAP
              FROM CONTAPAGAR
             WHERE CDFILIAL = :P_CDFILIAL
               AND NRLANCTONF = :P_NRLANCTONF
            GROUP BY DTATUAVENPAG
SQl;

        $params = array(
            "CDFILIAL"     => $cdfilial,
            "NRLANCTONF"   => $nrlanctonf,
            "IDORIGDESTNF" => $idorigdestnf,
            "DTENTRSAID"   => $dtentrsaid
        );

        return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
    }

    public function consultaFormaPagamentoSaida($cdfilial, $nrlanctonf, $idorigdestnf, \DateTime $dtentrsaid)
    {
        $dtentrsaid = $dtentrsaid->format($this->getEntityManager()->getConnection()->getDatabasePlatform()->getDateFormatString());
        $sql = <<<SQl
            SELECT DECODE(DTATUAVENREC, NULL, CONSULTA_FORMPGTO(:CDFILIAL, :NRLANCTONF, :IDORIGDESTNF),
                   DECODE(TO_DATE(MAX(DTATUAVENREC), 'DD/MM/YYYY HH24:MI:SS') - TO_DATE('{$dtentrsaid}', 'DD/MM/YYYY HH24:MI:SS'),0,0,1)) AS IDFORMPGTSAP
              FROM CONTARECEBER
             WHERE CDFILIAL = :CDFILIAL
               AND NRLANCTONF = :NRLANCTONF
            GROUP BY DTATUAVENREC
SQl;

        $params = array(
            "CDFILIAL"     => $cdfilial,
            "NRLANCTONF"   => $nrlanctonf,
            "IDORIGDESTNF" => $idorigdestnf,
//            "DTENTRSAID"   => $dtentrsaid
        );

        try{
            return self::getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getMaiorCodigoFormaPagamento($nrorg){
        try {
            $sql = <<<SQL
              SELECT NVL(MAX(CDFORMPGTO) + 1, 1) CDFORMPGTO
                FROM FORMPGTO
               WHERE NRORG = :P_NRORG
SQL;
            $params = array("P_NRORG" => $nrorg);

            return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

}