/* Teknisa - Tecnologia em Informtica

Nome: 3906_CDPFUNO.SQL

Descrio:
Funo para retornar a quantidade de Mat.Prima/Insumos calculada.

Criao:
04/06/2004 - Fabrcio Marcelo da Silva

@..\Sql\End_Conv\Oracle\3906_CDPFUNO.SQL
*/

CREATE OR REPLACE FUNCTION QTPREVI_MATPRIMA(
   P_CDFILIAL      IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO     IN PRODUTO.CDPRODUTO%TYPE,
   P_CDPROCFABRIC  IN TPROCFABRICA.CDPROCFABRIC%TYPE,
   P_CDETAPAPROD   IN ETAPAPROD.CDETAPAPROD%TYPE,
   P_CDPRODINSUMO  IN PRODUTO.CDPRODUTO%TYPE,
   P_QUANTIDADE    IN FLOAT,
   P_IDPROPORCAO   IN VARCHAR2 DEFAULT 'S',
   P_NRORDPROD     IN VARCHAR2 DEFAULT 'N',
   P_NRSUBORDPROD  IN VARCHAR2 DEFAULT 'N',
   P_IDLOTEPRETAP  IN VARCHAR2 DEFAULT 'N') RETURN FLOAT IS

   V_TIPPROPORCAO       VARCHAR2(01);
   V_TIPOARREDOND       VARCHAR2(01);
   V_QTINSUMETAPA       FLOAT;
   V_QTRENDINSU         FLOAT;
   V_QTDEPREVI          FLOAT;
   V_QTPADPROCFAB       FLOAT;
   V_IDUNIDADEVRINT     VARCHAR2(01);
   V_DSUNIDMEDIDA       VARCHAR2(1000);
   V_CONTUNIDMEDIDA     INT;

   V_IDPRODDIMEVAR      VARCHAR2(1); -- Identificar de Produto Dimensionvel
   V_ALTURA_PADRAO      FLOAT;       -- Valor da Altura Padro do Produto
   V_COMPRIMENTO_PADRAO FLOAT;       -- Valor do Comprimento Padro do Produto
   V_ALTURA_PEDIDO      FLOAT;       -- Valor da altura do produto pedido
   V_COMPRIMENTO_PEDIDO FLOAT;       -- Valor do comprimento do produto pedido
   V_CALCULA_PROPORCAO  BOOLEAN;     -- Varivel de controle para saber se existe possibilidade de calcular dimenso
   V_DIMENSAO_PADRAO    FLOAT;       -- Dimenso padro do produto
   V_DIMENSAO_PEDIDO    FLOAT;       -- Dimenso pedida do produto

   V_CDESPEPROD    VARCHAR2(10);
   V_QTPRACABADO   FLOAT;
   V_QTAPRODPREOP  FLOAT;
BEGIN

   SELECT
      MAX(INS.IDTIPOPROPOR),
      MAX(INS.IDTIPOARREDO),
      MAX(INS.QTINSUMETAPA),
      MAX(INS.QTRENDINSU),
      MAX(PR.QTPADPROCFAB)
   INTO
      V_TIPPROPORCAO,
      V_TIPOARREDOND,
      V_QTINSUMETAPA,
      V_QTRENDINSU,
      V_QTPADPROCFAB
   FROM
      INSUMETAPA INS,
      PROCFABRICA PR
   WHERE
      (INS.CDFILIAL     = P_CDFILIAL)     AND
      (INS.CDPRODUTO    = P_CDPRODUTO)    AND
      (INS.CDPROCFABRIC = P_CDPROCFABRIC) AND
      (INS.CDETAPAPROD  = P_CDETAPAPROD)  AND
      (INS.CDPRODINSUMO = P_CDPRODINSUMO) AND
      (INS.CDFILIAL     = PR.CDFILIAL)    AND
      (INS.CDPRODUTO    = PR.CDPRODUTO)   AND
      (INS.CDPROCFABRIC = PR.CDPROCFABRIC);

   /* O nmero da ordem de produo  informado geralmente
   na inicializao da OP. Nesse caso  necessrio verificar se o produto  um produto de dimenso varivel( Cadastro de Produto).
   Em caso positivo, verifica se a OP informada est ligada a algum pedido.
    necessrio verificar tambm se o produto possui Dimenso Padro informado (Processo de Fabricao) e Dimenso Pedida(Lanamento
   de Pedidos).
   Se todas essas condies estiverem OK, o sistema consegue calcular a quantidade proporcional do insumo, seno
   a funo  chamada novamente (com a varivel P_NRORDPROD = '') para calcular os insumos normalmente*/
   SELECT MAX(CDESPEPROD)
     INTO V_CDESPEPROD
     FROM ESPEPROD
    WHERE (CDFILIAL = P_CDFILIAL)
      AND (CDPRODUTO  = P_CDPRODUTO)
      AND (DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO)
                             FROM ESPEPROD
                            WHERE (CDFILIAL = P_CDFILIAL)
                              AND (CDPRODUTO  = P_CDPRODUTO)
                              AND (DTVALESPEPRO < SYSDATE)));
   IF V_CDESPEPROD IS NULL THEN
      SELECT MAX(E1.CDESPEPROD)
        INTO V_CDESPEPROD
        FROM ESPEPROD E1
       WHERE (E1.CDPRODUTO  = P_CDPRODUTO)
         AND (E1.DTVALESPEPRO = (SELECT MAX(E2.DTVALESPEPRO)
                                FROM ESPEPROD E2
                               WHERE (E1.CDFILIAL = E2.CDFILIAL)
                                 AND (E1.CDPRODUTO  = E2.CDPRODUTO)
                                 AND (E2.DTVALESPEPRO < SYSDATE)));
   END IF;

   IF V_CDESPEPROD IS NOT NULL THEN
      BEGIN
         SELECT MAX(QTPRODTCOMP)
           INTO V_QTRENDINSU
           FROM TCOMPPRO TC
          WHERE (TC.CDPRODUTO  = P_CDPRODUTO)
            AND (TC.CDESPEPROD = V_CDESPEPROD)
            AND (NVL(TC.IDTCOMPPROC,'N') = 'S');
      EXCEPTION
          WHEN NO_DATA_FOUND THEN
               V_QTRENDINSU := 0;
      END;
      IF  V_QTRENDINSU = 0 THEN
          SELECT MAX(QTPRODTCOMP)
            INTO V_QTRENDINSU
            FROM TCOMPPRO TC
           WHERE (TC.CDPRODUTO  = P_CDPRODUTO)
             AND (TC.CDESPEPROD = V_CDESPEPROD);
      END IF;
   END IF;

   IF (NVL(P_IDLOTEPRETAP, 'N') <> 'S') THEN
      IF P_IDPROPORCAO = 'S' THEN
         IF V_TIPPROPORCAO = 'N' THEN
            IF V_TIPOARREDOND = '1' THEN
               V_QTDEPREVI := TRUNC((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU)+1;
            ELSE
               IF V_TIPOARREDOND = '2' THEN
                  V_QTDEPREVI := TRUNC((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
               ELSE
                  V_QTDEPREVI := ((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
               END IF;
            END IF;
         ELSE
            IF V_TIPPROPORCAO = 'L' THEN
               IF V_TIPOARREDOND = '1' THEN
                  IF (MOD(P_QUANTIDADE, V_QTPADPROCFAB) <> 0) THEN
                     V_QTDEPREVI := ((TRUNC(P_QUANTIDADE / V_QTPADPROCFAB) + 1) * V_QTINSUMETAPA);
                  ELSE
                     V_QTDEPREVI := ((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA);
                  END IF;
               ELSE
                  IF V_TIPOARREDOND = '2' THEN
                     V_QTDEPREVI := ((TRUNC(P_QUANTIDADE / V_QTPADPROCFAB)) * V_QTINSUMETAPA);
                  END IF;
               END IF;
            ELSE
               IF V_TIPPROPORCAO = 'U' THEN
                  V_QTDEPREVI := V_QTINSUMETAPA;
               ELSE
                  IF V_TIPPROPORCAO = 'I' THEN
                     IF V_TIPOARREDOND = '0' THEN
                        V_QTDEPREVI := (ROUND((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                     ELSE
                        IF V_TIPOARREDOND = '1' THEN
                           IF (MOD(P_QUANTIDADE, V_QTINSUMETAPA) <> 0) THEN
                              IF (MOD(ROUND(((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA)),1)= 0) THEN
                                  V_QTDEPREVI := (ROUND((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                              ELSE
                                  V_QTDEPREVI := (TRUNC((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA)+ 1);
                              END IF;
                           ELSE
                              V_QTDEPREVI := ((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA);
                           END IF;
                        ELSE
                           IF V_TIPOARREDOND = '2' THEN
                              V_QTDEPREVI := (TRUNC((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         END IF;
      ELSE
         V_QTDEPREVI := ((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
      END IF;
   ELSE
      IF (NVL(P_NRORDPROD, 'N') <> 'N') THEN
         SELECT SUM(P.QTPRACABADO) QTPRACABADO, SUM(O.QTAPRODPREOP) QTAPRODPREOP
           INTO V_QTPRACABADO, V_QTAPRODPREOP
           FROM ORDPRODUCAO O, PRODACABADO P
          WHERE O.CDFILIAL     = P_CDFILIAL
            AND O.NRORDPROD    = P_NRORDPROD
            AND O.NRSUBORDPROD = TO_CHAR(TO_NUMBER(P_NRSUBORDPROD)-1)
            AND O.CDFILIAL     = P.CDFILIAL
            AND O.CDPRODUTO    = P.CDPRODUTO
            AND O.NRORDPROD    = P.NRORDPROD
            AND O.NRSUBORDPROD = P.NRSUBORDPROD
            AND O.CDPRODUTO    = P.CDPRODUTO;

         V_QTDEPREVI := V_QTPRACABADO;
      ELSE
         IF P_IDPROPORCAO = 'S' THEN
            IF V_TIPPROPORCAO = 'N' THEN
               IF V_TIPOARREDOND = '1' THEN
                  V_QTDEPREVI := TRUNC((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU)+1;
               ELSE
                  IF V_TIPOARREDOND = '2' THEN
                     V_QTDEPREVI := TRUNC((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
                  ELSE
                     V_QTDEPREVI := ((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
                  END IF;
               END IF;
            ELSE
               IF V_TIPPROPORCAO = 'L' THEN
                  IF V_TIPOARREDOND = '1' THEN
                     IF (MOD(P_QUANTIDADE, V_QTPADPROCFAB) <> 0) THEN
                        V_QTDEPREVI := ((TRUNC(P_QUANTIDADE / V_QTPADPROCFAB) + 1) * V_QTINSUMETAPA);
                     ELSE
                        V_QTDEPREVI := ((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA);
                     END IF;
                  ELSE
                     IF V_TIPOARREDOND = '2' THEN
                        V_QTDEPREVI := ((TRUNC(P_QUANTIDADE / V_QTPADPROCFAB)) * V_QTINSUMETAPA);
                     END IF;
                  END IF;
               ELSE
                  IF V_TIPPROPORCAO = 'U' THEN
                     V_QTDEPREVI := V_QTINSUMETAPA;
                  ELSE
                     IF V_TIPPROPORCAO = 'I' THEN
                        IF V_TIPOARREDOND = '0' THEN
                           V_QTDEPREVI := (ROUND((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                        ELSE
                           IF V_TIPOARREDOND = '1' THEN
                              IF (MOD(P_QUANTIDADE, V_QTINSUMETAPA) <> 0) THEN
                                 IF (MOD(ROUND(((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA)),1)= 0) THEN
                                    V_QTDEPREVI := (ROUND((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                                 ELSE
                                    V_QTDEPREVI := (TRUNC((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA)+ 1);
                                 END IF;
                              ELSE
                                 V_QTDEPREVI := ((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA);
                              END IF;
                           ELSE
                              IF V_TIPOARREDOND = '2' THEN
                                 V_QTDEPREVI := (TRUNC((P_QUANTIDADE / V_QTPADPROCFAB) * V_QTINSUMETAPA));
                              END IF;
                           END IF;
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END IF;
         ELSE
            V_QTDEPREVI := ((P_QUANTIDADE * V_QTINSUMETAPA) / V_QTRENDINSU);
         END IF;
      END IF;   
      /*  
      -- Proporo deve ser normal
      IF V_TIPPROPORCAO = 'N' THEN
         V_CALCULA_PROPORCAO := TRUE;
      ELSE
         V_CALCULA_PROPORCAO := FALSE;
      END IF;

      -- Produto Dimensionvel
      IF V_CALCULA_PROPORCAO THEN
         BEGIN
            SELECT NVL(IDPRODDIMEVAR, 'N') IDPRODDIMEVAR
              INTO V_IDPRODDIMEVAR
              FROM PRODUTO
             WHERE CDPRODUTO = P_CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDPRODDIMEVAR := 'N';
         END;
      END IF;

      IF V_IDPRODDIMEVAR = 'S' THEN
         V_CALCULA_PROPORCAO := TRUE;
      ELSE
         V_CALCULA_PROPORCAO := FALSE;
      END IF;

      -- Verifica se existe dimenso padro cadastrada
      IF V_CALCULA_PROPORCAO THEN
         BEGIN
            SELECT NVL(P.VRALTPADRPROD, 0) VRALTPADRPROD,
                   NVL(P.VRCOMPADRPROD, 0) VRCOMPADRPROD
              INTO V_ALTURA_PADRAO, V_COMPRIMENTO_PADRAO
              FROM PROCFABRICA P, ORDPRODUCAO O
             WHERE P.CDPRODUTO      = P_CDPRODUTO    AND
                   P.CDFILIAL       = P_CDFILIAL     AND
                   P.CDFILIAL       = O.CDFILIAL     AND
                   P.CDPRODUTO      = O.CDPRODUTO    AND
                   P.CDPROCFABRIC   = O.CDPROCFABRIC AND
                   O.NRORDPROD      = P_NRORDPROD    AND
                   O.NRSUBORDPROD   = P_NRSUBORDPROD AND
                   P.IDCALCINSUPROP = 'S';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_ALTURA_PADRAO      := 0;
               V_COMPRIMENTO_PADRAO := 0;
         END;

         IF ((V_ALTURA_PADRAO = 0) OR (V_COMPRIMENTO_PADRAO = 0)) THEN
            V_CALCULA_PROPORCAO := FALSE;
         END IF;

      END IF;

      IF V_CALCULA_PROPORCAO THEN
         -- Verifica se existe dimenso informada no pedido
         BEGIN
            SELECT NVL(I.VRALTURAPROD, 0) VRALTURAPROD,
                   NVL(I.VRCOMPRIPROD, 0) VRCOMPRIPROD
              INTO V_ALTURA_PEDIDO, V_COMPRIMENTO_PEDIDO
              FROM ITEMPEDIDO I, ORDPRODUCAO O
             WHERE I.CDFILIAL     = P_CDFILIAL  AND
                   I.CDPRODUTO    = P_CDPRODUTO AND
                   I.CDFILIAL     = O.CDFILIAL  AND
                   I.CDPRODUTO    = O.CDPRODUTO AND
                   I.NRPEDIDO     = O.NRPEDIDO  AND
                   I.NRITEMPED    = O.NRITEMPED AND
                   O.NRORDPROD    = P_NRORDPROD AND
                   O.NRSUBORDPROD = P_NRSUBORDPROD;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_ALTURA_PEDIDO      := 0;
               V_COMPRIMENTO_PEDIDO := 0;
         END;

         IF ((V_ALTURA_PEDIDO = 0) OR (V_COMPRIMENTO_PEDIDO = 0)) THEN
            V_CALCULA_PROPORCAO := FALSE;
         END IF;

      END IF;

      -- Se no for possvel calcular a quantidade de matria prima de acordo com os parmetros informados de dimenses,
      -- o sistema calcula a quantidade proporcional normalmente chamando novamente a funo (Informando N para o parmetro de OP)

      IF NOT V_CALCULA_PROPORCAO THEN
         V_QTDEPREVI := QTPREVI_MATPRIMA(P_CDFILIAL, P_CDPRODUTO, P_CDPROCFABRIC, P_CDETAPAPROD, P_CDPRODINSUMO, P_QUANTIDADE, P_IDPROPORCAO, 'N', 'N');
      ELSE
         -- Realiza o clculo da dimenso
         -- Dimensao_Padrao(rea padro)     ------- Quantidade_Materia_Prima
         -- Dimensao_Pedida(rea do pedido)  ------- X
         

         V_DIMENSAO_PADRAO := V_ALTURA_PADRAO * V_COMPRIMENTO_PADRAO;
         V_DIMENSAO_PEDIDO := V_ALTURA_PEDIDO * V_COMPRIMENTO_PEDIDO;

         V_QTDEPREVI := ((V_DIMENSAO_PEDIDO * V_QTINSUMETAPA) / V_DIMENSAO_PADRAO);
      END IF;
      */
   END IF;

   -- Verifica, de acordo com a unidade de medida, se o valor encontrado deve somente valor inteiro
   BEGIN
      SELECT NVL(P.IDUNIDADEVRINT, 'N'), P.DSUNIDMEDIDA, INSTR(P.DSUNIDMEDIDA, PR.SGUNIDADE)
        INTO V_IDUNIDADEVRINT, V_DSUNIDMEDIDA, V_CONTUNIDMEDIDA
        FROM PARAMAN P, PRODUTO PR
       WHERE P.CDFILIAL   = P_CDFILIAL
         AND PR.CDPRODUTO = P_CDPRODINSUMO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
      V_IDUNIDADEVRINT := NULL;
      V_DSUNIDMEDIDA   := NULL;
      V_CONTUNIDMEDIDA := 0;
   END;

   IF (V_IDUNIDADEVRINT = 'S') AND (V_CONTUNIDMEDIDA > 0) THEN
      IF TRUNC(V_QTDEPREVI, 0) > 0 THEN
         IF (V_QTDEPREVI / TRUNC(V_QTDEPREVI, 0)) <> 1 THEN
            V_QTDEPREVI := V_QTDEPREVI + 1;
            V_QTDEPREVI := TRUNC(V_QTDEPREVI, 0);
         END IF;
      ELSE
         V_QTDEPREVI := V_QTDEPREVI + 1;
         V_QTDEPREVI := TRUNC(V_QTDEPREVI, 0);      
      END IF;
   END IF;

   RETURN(V_QTDEPREVI);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('QTPREVI_MATPRIMA','6.35.031'); END;
/
