/*
 NOME: EXPORTA_TABELA_TG

 DESCRIO: Procedimento para gerao do TG em tabela.

 CRIAO: 05/10/2006 - Rejane P. Leite

 @C:\web_550\sql\end_conv\oracle\clientes\grs\4100_GERSTPO_EXPORTA_TABELA_TG.sql

 RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE EXPORTA_TABELA_TG(
     P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
     P_DTINICIAL IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_TIPOEXPTG IN NOTAFISCAL.IDSTATUS%TYPE)
AS
   V_DTATUAVENPAG   DATE;
   V_DTATUAVENREC   DATE;
   V_VRDESPESA      FLOAT;
   V_VRDESCONTO     FLOAT;
   V_VRICMSRETI     FLOAT;
   V_VRIRRETIDO     FLOAT;
   V_VRIPIPROD      FLOAT;
   V_VRSOMANUMNFE   NUMBER;
   V_VRSOMANUMNFS   NUMBER;
   V_VRSOMANUMNF    NUMBER;
   V_VALOR          NUMBER;
   V_NRSEQVENPAG    VARCHAR2(2);
   V_NRPARCELAPAG   VARCHAR2(2);
   V_CDFILIBPAG     VARCHAR2(4);
   V_NRLANBOLPAG    VARCHAR2(10);
   V_CDREDUCONT     VARCHAR2(3);
   V_NRLANBOLETO    VARCHAR2(21);
   V_CDENCARGO      VARCHAR2(5);
   V_CDIMPOSTOT     VARCHAR2(2);
   V_CDIMPOSTOIT    VARCHAR2(2);
   V_NRITPROIMPOS   VARCHAR2(1);
   V_NRSEQUITNOTA   VARCHAR2(3);
   V_CDFILIORIGDE   VARCHAR2(4);
   V_NRNOTAORIGDE   VARCHAR2(9);
   V_CDSERORIGDE    VARCHAR2(5);
   V_NRIJURORIGDE   VARCHAR2(20);
   V_NRSEQVENREC    VARCHAR2(2);
   V_NRPARCELAREC   VARCHAR2(2);
   V_CDFILIBREC     VARCHAR2(4);
   V_NRLANBOLREC    VARCHAR2(10);
   V_CDNOSNUMREC    VARCHAR2(21);
   V_IDENTRSAID     VARCHAR2(1);
   V_STATUSCANC     VARCHAR2(1);
   V_IDSISDFE       VARCHAR2(3);
   V_IDSISEST       VARCHAR2(3);
   V_IDSISDFS       VARCHAR2(3);
   V_IDSISFAI       VARCHAR2(3);
   V_IDSISFAS       VARCHAR2(3);
   V_IDSISFAC       VARCHAR2(3);
   V_IDSISPDV       VARCHAR2(3);
   V_TIPO1          VARCHAR2(2);
   V_TIPO2          VARCHAR2(2);
   V_TIPO3          VARCHAR2(2);
   V_TIPO4          VARCHAR2(2);
   V_TIPO5          VARCHAR2(2);
   V_TIPO8          VARCHAR2(2);
   V_TIPO9          VARCHAR2(2);
   V_TIPO10         VARCHAR2(2);
   V_TIPO12         VARCHAR2(2);
   V_TIPO13         VARCHAR2(2);
   V_TIPO20         VARCHAR2(2);
   V_TPNF4          VARCHAR2(1);
   V_TPNF3          VARCHAR2(1);
   V_TPNF1          VARCHAR2(1);
   V_TPNF2          VARCHAR2(1);
   V_TPNF8          VARCHAR2(1);
   V_IDTPIJURNF     VARCHAR2(1);
   V_PRIMDIA        VARCHAR2(3);
   V_IDTIPODADOL    VARCHAR2(1);
   V_IDTIPODADOA    VARCHAR2(1);
   V_STRING         VARCHAR2(1);
   V_STATUSEMI      VARCHAR2(1);
   V_IDSTCANCNF     VARCHAR2(1);
   V_ZERO           VARCHAR2(1);
   V_ESPACO         VARCHAR2(1);
   V_TRACO          VARCHAR2(1);

   V_DTMOVIEXPTG    DATE;
   V_NRINSJURNFTG   VARCHAR2(14);
   V_CDINSCESTA     VARCHAR2(16);
BEGIN

   /*INICIALIZAO DAS VARIAVEIS*/
   V_IDENTRSAID  := 'S';
   V_STATUSCANC  := 'C';
   V_STATUSEMI   := 'E';
   V_IDSISDFE    := 'DFE';
   V_IDSISEST    := 'EST';
   V_IDSISDFS    := 'DFS';
   V_IDSISFAI    := 'FAI';
   V_IDSISFAS    := 'FAS';
   V_IDSISFAC    := 'FAC';
   V_IDSISPDV    := 'PDV';
   V_TIPO1       := '01';
   V_TIPO2       := '02';
   V_TIPO3       := '03';
   V_TIPO4       := '04';
   V_TIPO5       := '05';
   V_TIPO8       := '08';
   V_TIPO9       := '09';
   V_TIPO10      := '10';
   V_TIPO12      := '12';
   V_TIPO13      := '13';
   V_TIPO20      := '20';
   V_TPNF4       := '4';
   V_TPNF3       := '3';
   V_TPNF1       := '1';
   V_TPNF2       := '2';
   V_TPNF8       := '8';
   V_IDTPIJURNF  := 'I';
   V_PRIMDIA     := '01/';
   V_IDTIPODADOL := 'L';
   V_IDTIPODADOA := 'A';
   V_STRING      := '';
   V_VALOR       := 0;
   V_ZERO        := '0';
   V_ESPACO      := ' ';
   V_TRACO       := '-';

   /* EXPORTAO DO TG NORMAL*/
   IF P_TIPOEXPTG = 'F' THEN

      /* APAGA OS REGISTROS DA TABELA ANTES DE EXPORTAR (CHAVE DE EXCLUSAO : EMPRESA, FILIAL DO RE, NMERO DO RE, DATA DE MOVIMENTACAO*/
      BEGIN
         SELECT TO_DATE(NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES)||'/'||TO_CHAR(P_DTINICIAL,'MM/YYYY'))
           INTO V_DTMOVIEXPTG
           FROM PARAMFILIAL P, (SELECT D.DTFECMES, D.CDFILIAL
                                  FROM DIAFECMES D
                                 WHERE D.CDFILIAL = P_CDFILIAL
                                   AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
          WHERE P.CDFILIAL = P_CDFILIAL
            AND P.CDFILIAL = D.CDFILIAL(+)
            AND P.IDCTRLESTQ = 'S';
      EXCEPTION
      WHEN NO_DATA_FOUND THEN
          V_DTMOVIEXPTG := P_DTINICIAL;
      WHEN OTHERS THEN 
          V_DTMOVIEXPTG := LAST_DAY(P_DTINICIAL);
      END;


      IF V_DTMOVIEXPTG IS NULL THEN
         V_DTMOVIEXPTG := P_DTINICIAL;
      END IF;

      IF P_DTINICIAL <= V_DTMOVIEXPTG THEN
         V_DTMOVIEXPTG := P_DTINICIAL;
      ELSE
         V_DTMOVIEXPTG := TO_DATE('01/'||TO_CHAR(ADD_MONTHS(P_DTINICIAL,1),'MM/YYYY'));
      END IF;

      DELETE FROM EXPORTACAOTG
      WHERE EXISTS
         (SELECT F.CDFILIAL
            FROM FILIAL F, NUMERORNF RE
           WHERE F.CDFILIAL = P_CDFILIAL
             AND CDEMPRESATG = F.CDEMPRESA
             AND RE.CDFILIAL = P_CDFILIAL
             AND RE.DTNUMERNF = P_DTINICIAL
             AND CDFILIALRE = RE.CDFILIAL
             AND NRNUMERORETG = SUBSTR(NRNUMERNF,7,10)
             AND DTMOVIEXPTG = V_DTMOVIEXPTG);

      V_IDENTRSAID := 'E';

      /* GERA AS NF'S DE ENTRADA */
      FOR C_ENTRADA IN (SELECT PF.IDTIPODADOTG, N.CDTIPOOPER, N.CDALMOXARIFE, N.CDLOCALESTOQ,
                            (DECODE(N.IDENTRSAIDOP, NULL, NVL(NVL(CDEXFILIAL,N.CDFILIAL),'    '),
                             DECODE(IDTIPODADOTG, V_IDTIPODADOL, NVL(SUBSTR(I.CDLOCALESTOQ,
                             DECODE(LENGTH(I.CDLOCALESTOQ),6,3,5,2,1),4),'    '), V_IDTIPODADOA, NVL(SUBSTR(I.CDALMOXARIFE,
                             DECODE(LENGTH(I.CDALMOXARIFE),6,3,5,2,1),4),'    ') ,NVL(NVL(CDEXFILIAL,N.CDFILIRECE),'    ')))) AS CDFILIALTG,
                            N.CDEMPRESA, N.CDFILIAL, NVL(SUBSTR(N.NRSEQCAPADOC,7,10),'    ') AS NRNUMRETG,
                            N.NRSEQCAPADOC AS NRNUMERNF, DATA.DTENTRSAID,
                            N.DTENTRSAID AS DTRECEBIMENTO,
                            (DECODE(T.CDTIPOOPER, V_TIPO12,
                              DECODE(IDTPNFCREDEB, V_TPNF2, NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),1,2),'  '),
                              DECODE(IDTPNFCREDEB,V_TPNF4,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),3,2),'  '),
                              DECODE(IDTPNFCREDEB,V_TPNF3,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),5,2),'  '),
                              DECODE(IDTPNFCREDEB,V_TPNF1,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),7,2),'  '),
                              NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),1,2),'  '))))),NVL(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),'  '))) AS CDTIPOOPERTG,
                            NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER) AS DSTIPOOPER,
                            N.IDTPIJURNF, DECODE(IDTPIJURNF, V_IDTPIJURNF, SUBSTR(NRINSJURNF,7,14) , NRINSJURNF) AS NRINSJURNF,
                            SUBSTR(NVL(NRNOTAFISC,LPAD('0',NVL(PF.NRTAMNUMNFUTDFE,7),'0')),1,9) AS NRNOTAFISC,
                            SUBSTR(N.CDSERIEENTR,1,4) AS CDSERIE,
                            N.DTEMISSAO,
                            SUBSTR(NVL(PROD.CDPRODINTE,PROD.CDARVPROD),1,10) CDPRODUTOTG,
                            I.QTITEMPROD, I.VRUNITITEM, I.VRDESCITEM, I.IDTPNFCREDEB,
                            N.VRNOTAFISC, N.CDFILIEMIT, 'S' AS IDALTERADA, N.IDENTRSAIDOP,
                            T.CDTIPOOPER AS TIPOOPER, PF.CDEXFILIAL,
                            N.NRLANCTONF, I.NRSEQITPROD, N.CDFILIRECE AS CDFILIALRE, N.DTENTRSAID AS DTNUMERNF,
                            N.CDINSCESTA, V_IDENTRSAID AS IDTIPOOPERNF, PROD.CDPRODUTO, N.IDSTATUS,
                            N.DTCANCELANF, P.DSOBPARAMEMISRE, N.NRCPFCNPJNF, I.CDALMOXARIFE AS CDALMOXITEM
                     FROM NOTAFISCAL N,   ITEMPRODUTO I,  PRODUTO PROD,
                          TIPOOPERAC  T,  PARAMFILIAL PF, USR_CDEXPFITPOP U,
                          PARAMEMISSAORE P,
                         (SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, TO_DATE('01/'||TO_CHAR(ADD_MONTHS(F.DTENTRSAID,1),'MM/YYYY')) AS DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIRECE   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIRECE)  AND
                                 (T.DTDIAFECMES) <  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIRECE   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIRECE)  AND
                                 (T.DTDIAFECMES) >=  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIRECE   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIRECE)  AND
                                 (T.DTDIAFECMES IS NULL)) DATA

                     WHERE (N.CDFILIRECE       = P_CDFILIAL)         AND
                           (N.DTENTRSAID       = P_DTINICIAL)        AND
                           (N.IDENTRSAIDOP     = V_IDENTRSAID)       AND
                           (N.IDSISTEMA        = V_IDSISDFE          OR
                            N.IDSISTEMA        = V_IDSISEST          OR
                            N.IDSISTEMA IS NULL)                     AND
                           (N.CDFILIAL         = I.CDFILIAL)         AND
                           (N.NRLANCTONF       = I.NRLANCTONF)       AND
                           (N.CDFILIRECE       = PF.CDFILIAL)        AND
                           (N.CDTIPOOPER       = T.CDTIPOOPER)       AND
                           (N.IDENTRSAIDOP     = T.IDENTRSAIDOP)     AND
                           (NVL(T.IDCOMPGERTG, 'F') = 'F')           AND
                           (N.CDTIPOOPER       = U.CDTIPOOPER(+))    AND
                           (N.IDENTRSAIDOP     = U.IDENTRSAIDOP(+))  AND
                           (N.CDFILIRECE       = U.CDFILIAL(+))      AND
                           (N.CDFILIAL         = DATA.CDFILIAL(+))   AND
                           (N.NRLANCTONF       = DATA.NRLANCTONF(+)) AND
                           (I.CDPRODUTO        = PROD.CDPRODUTO)     AND
                           (N.CDPARAMEMISRE    = P.CDPARAMEMISRE (+))) LOOP

          V_VRSOMANUMNFE := 0;

          /* RETORNA A SOMA DO NMERO DAS NF'S DE ENTRADA*/
          SELECT SUM(NVL(TO_NUMBER(A.NRNOTAFISC),0))
            INTO V_VRSOMANUMNFE
            FROM (SELECT DISTINCT NRNOTAFISC
                     FROM NOTAFISCAL N, ITEMPRODUTO I, TIPOOPERAC T
                    WHERE N.CDFILIRECE = P_CDFILIAL
                      AND N.IDENTRSAIDOP = V_IDENTRSAID
                      AND N.CDTIPOOPER = T.CDTIPOOPER
                      AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                      AND NVL(T.IDCOMPGERTG, 'F') = 'F'
                      AND N.NRSEQCAPADOC = C_ENTRADA.NRNUMERNF
                      AND N.IDSTATUS <> V_STATUSCANC
                      AND N.DTENTRSAID = P_DTINICIAL
                      AND I.CDFILIAL = N.CDFILIAL
                      AND I.NRLANCTONF = N.NRLANCTONF
                      AND NVL(I.CDALMOXARIFE, ' ') = NVL(C_ENTRADA.CDALMOXITEM, ' ')
                      AND (N.IDSISTEMA = V_IDSISDFE OR
                           N.IDSISTEMA = V_IDSISEST OR
                           N.IDSISTEMA IS NULL)) A;

          /* INFORMAES FINANCEIRAS*/
          SELECT MIN(DTATUAVENPAG) AS DTATUAVENPAG, MIN(NRSEQVENPAG) AS NRSEQVENPAG,
                 MIN(NRPARCELAPAG) AS NRPARCELAPAG, MIN(C.CDFILIBPAG) AS CDFILIBPAG,
                 MIN(B.NRLANBOLPAG) AS NRLANBOLPAG,
                 MIN(B.CDREDUCONT) AS CDREDUCONT,
                 SUBSTR(MIN(CDAGENCIA),1,4)||MIN(CDNOSNUMPAG) CDNOSNUMPAG
          INTO V_DTATUAVENPAG, V_NRSEQVENPAG, V_NRPARCELAPAG, V_CDFILIBPAG,
                 V_NRLANBOLPAG, V_CDREDUCONT, V_NRLANBOLETO
          FROM CONTAPAGAR C, BOLETPAGAR B, CONTCORR E
          WHERE C.CDFILIAL      = C_ENTRADA.CDFILIAL   AND
                C.NRLANCTONF    = C_ENTRADA.NRLANCTONF AND
                C.CDFILIBPAG    = B.CDFILIAL(+)        AND
                C.NRLANBOLPAG   = B.NRLANBOLPAG(+)     AND
                E.CDREDUCONT(+) = B.CDREDUCONT;

          /* ENCARGOS DA NOTA FISCAL */
          SELECT MIN(CDENCARGO),
                 SUM(DECODE(CDENCARGO, V_TIPO1, VRITEMENCA, V_TIPO2, VRITEMENCA, V_TIPO3, VRITEMENCA, 0)),
                 SUM(DECODE(CDENCARGO, V_TIPO4, VRITEMENCA, 0)),
                 SUM(DECODE(CDENCARGO, V_TIPO5, VRITEMENCA, 0))
          INTO V_CDENCARGO, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI
          FROM ITEMENCARGO
          WHERE CDFILIAL   = C_ENTRADA.CDFILIAL  AND
                NRLANCTONF = C_ENTRADA.NRLANCTONF;

          /* VALOR DO IMPOSTO RETIDO - 20*/
          SELECT MAX(CDIMPOSTO), SUM(VRTOTIMPONF)
          INTO V_CDIMPOSTOT, V_VRIRRETIDO
          FROM IMPOSNFTOT
          WHERE CDFILIAL   = C_ENTRADA.CDFILIAL    AND
                NRLANCTONF = C_ENTRADA.NRLANCTONF  AND
                CDIMPOSTO  = V_TIPO20;

          /* VALOR DO IMPOSTO IPI - 10*/
          SELECT MAX(CDIMPOSTO), MAX(NRITPROIMPOS),
                 SUM(VRIMPOSTOIT)
          INTO V_CDIMPOSTOIT, V_NRITPROIMPOS, V_VRIPIPROD
          FROM  ITEMPRODUTO ITU, ITEMPROIMPOS IMPIT
          WHERE ITU.CDFILIAL    = C_ENTRADA.CDFILIAL    AND
                ITU.NRLANCTONF  = C_ENTRADA.NRLANCTONF  AND
                ITU.NRSEQITPROD = C_ENTRADA.NRSEQITPROD AND
                ITU.CDFILIAL    = IMPIT.CDFILIAL        AND
                ITU.NRLANCTONF  = IMPIT.NRLANCTONF      AND
                ITU.NRSEQITPROD = IMPIT.NRSEQITPROD     AND
                IMPIT.CDIMPOSTO = V_TIPO10;

          SELECT MAX(NA.CDFILIEMIT), MAX(SUBSTR(NA.NRNOTAFISC,1,9)),
                 MAX(FIS.NRSEQUITNOTA), MAX(NVL(NA.CDSERIE, NA.CDSERIEENTR)), MAX(NA.NRINSJURNF)
          INTO V_CDFILIORIGDE, V_NRNOTAORIGDE, V_NRSEQUITNOTA,
               V_CDSERORIGDE, V_NRIJURORIGDE
          FROM NOTAFISCAL NA, ITEMNOTAFISC FIS
          WHERE FIS.CDFILIAL     = C_ENTRADA.CDFILIAL   AND
                FIS.NRLANCTONF   = C_ENTRADA.NRLANCTONF AND
                NA.CDFILIAL   = C_ENTRADA.CDFILIAL      AND
                NA.NRLANCTONF = C_ENTRADA.NRLANCTONF    AND
                FIS.CDFILIALIT   = NA.CDFILIAL          AND
                FIS.NRLANCTONFIT = NA.NRLANCTONF;

          IF C_ENTRADA.IDSTATUS = 'C' THEN
             V_IDSTCANCNF := 'S';
          ELSE
             V_IDSTCANCNF := 'N';
          END IF;

          V_NRLANBOLETO := REPLACE(V_NRLANBOLETO, '-', '');

          IF LENGTH(RTRIM(V_NRIJURORIGDE)) > 14 THEN
             V_NRIJURORIGDE := SUBSTR(V_NRIJURORIGDE, 7, 14);
          END IF;

   /*INSERE AS NF'S DE ENTRADA DO TG NORMAL*/
         INSERT INTO EXPORTACAOTG
            (CDEMPRESATG, CDFILIALTG, NRNUMERORETG, DTCONTABILTG, VRSOMNUMDCTG,CDTIPOOPERTG, IDTPIJURNFTG, NRINSJURNFTG, NRNOTAFISCTG, CDSERIEENTTG, DTEMISSAOTG, DTATVENPAGTG,
             CDFILIRECETG, VRDESPESATG, VRDESCONTOTG, VRICMSRETITG, VRIRRETIDOTG, NRINIMAQRETG, NRFIMMAQRETG, NRTOTMAQRETG, CDPRODUTOTG, QTITEMPRODTG, VRUNITITEMTG, VRDESCITEMTG,
             VRIPIPRODTG, VRNOTAFISCTG, CDFILIEMITTG, IDALTERADATG, CDFIORIGDETG, CDSERORIDETG, NRIJURORIGDE, CDCFISCOPTG, NRLANBOLETTG, VRDOTACAOTG, VRIMPINSSTG, VRIMPISSTG,
             NRMAQREGTG, NRREDUCAOTG, VLRMAQRETG, VLRCANCANTG, CROTG, DTRECEBIMTG, CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO, IDENTRSAIDOP, CDTIPOOPER, DTNUMERNF, IDENTRSAID,
             IDTIPOOPERNF, NRSEQVENPAG, NRPARCELAPAG, NRLANBOLPAG, CDREDUCONT, CDENCARGO, CDIMPOSTOT, CDIMPOSTO, NRITPROIMPOS, NRSEQUITNOTA, CDEMPRESA, CDINSCESTA, NRSEQVENREC,
             NRPARCELAREC, NRLANBOLREC, IDSTCANCNF, DTCANCNFTG, CDFILIBPAG, CDFILIBREC, CDFILIALRE, NRNUMERNF, DTMOVIEXPTG, IDTIPOEXPTG,
             DSOBSERVRETG, NRCPFCNPJNFTG)
         VALUES
            (C_ENTRADA.CDEMPRESA, C_ENTRADA.CDFILIALTG, C_ENTRADA.NRNUMRETG, C_ENTRADA.DTENTRSAID, V_VRSOMANUMNFE, C_ENTRADA.CDTIPOOPERTG,
             C_ENTRADA.IDTPIJURNF, C_ENTRADA.NRINSJURNF, C_ENTRADA.NRNOTAFISC, C_ENTRADA.CDSERIE, C_ENTRADA.DTEMISSAO, V_DTATUAVENPAG,
             ''/*CDFILIRECE*/, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI, V_VRIRRETIDO, '0000000000' /*VRIMAQRE*/,
             '0000000000' /*VRFMAQRE*/, '0000000000' /*VRAMAQRE*/, C_ENTRADA.CDPRODUTOTG, C_ENTRADA.QTITEMPROD, C_ENTRADA.VRUNITITEM, C_ENTRADA.VRDESCITEM,
             V_VRIPIPROD, C_ENTRADA.VRNOTAFISC, C_ENTRADA.CDFILIEMIT, C_ENTRADA.IDALTERADA, V_NRNOTAORIGDE, V_CDSERORIGDE,
             V_NRIJURORIGDE, '' /*CDFISCOPTG*/, V_NRLANBOLETO, 0 /*VRDOTACAO*/, 0/*VRIMPINSSTG*/, 0 /*VRIMPISSTG*/,
             '' /*NRMAQREGTG*/, '' /*NRREDUCAOTG*/, 0 /*VLRMAQRETG*/, 0 /*VLRCANCANTG*/, '' /*CROTG*/, C_ENTRADA.DTRECEBIMENTO, C_ENTRADA.CDFILIAL,
             C_ENTRADA.NRLANCTONF, C_ENTRADA.NRSEQITPROD, C_ENTRADA.CDPRODUTO, C_ENTRADA.IDENTRSAIDOP, C_ENTRADA.TIPOOPER, C_ENTRADA.DTNUMERNF, C_ENTRADA.IDENTRSAIDOP,
             C_ENTRADA.IDTIPOOPERNF, V_NRSEQVENPAG, V_NRPARCELAPAG, V_NRLANBOLPAG, V_CDREDUCONT, V_CDENCARGO, V_CDIMPOSTOT,
             V_CDIMPOSTOIT, V_NRITPROIMPOS, V_NRSEQUITNOTA, C_ENTRADA.CDEMPRESA, C_ENTRADA.CDINSCESTA, ''/*NRSEQVENREC*/, '' /*NRPARCELAREC*/,
             '' /*NRLANBOLREC*/, V_IDSTCANCNF, C_ENTRADA.DTCANCELANF, V_CDFILIBPAG, '' /*CDFILIBREC*/, C_ENTRADA.CDFILIALRE, C_ENTRADA.NRNUMERNF, C_ENTRADA.DTENTRSAID, 'F',
             C_ENTRADA.DSOBPARAMEMISRE, C_ENTRADA.NRCPFCNPJNF);

      END LOOP;


      /* GERA AS NF'S DE SADA */
      V_IDENTRSAID := 'S';

      FOR C_SAIDA IN (SELECT PF.IDTIPODADOTG, N.CDTIPOOPER, I.CDALMOXARIFE, I.CDLOCALESTOQ,
                        (DECODE(N.IDENTRSAIDOP, NULL, NVL(NVL(CDEXFILIAL,N.CDFILIAL),'    '),
                         DECODE(IDTIPODADOTG, V_IDTIPODADOL, NVL(SUBSTR(I.CDLOCALESTOQ,
                         DECODE(LENGTH(I.CDLOCALESTOQ),6,3,5,2,1),4),'    '), V_IDTIPODADOA, NVL(SUBSTR(I.CDALMOXARIFE,
                             DECODE(LENGTH(I.CDALMOXARIFE),6,3,5,2,1),4),'    ') ,NVL(NVL(CDEXFILIAL, N.CDFILIEMIT),'    ')))) AS CDFILIALTG,
                         N.CDFILIEMIT,
                         NVL(SUBSTR(N.NRSEQCAPADOC,7,10),'    ') AS NRNUMRETG,
                         N.NRSEQCAPADOC AS NRNUMERNF,
                         DATA.DTENTRSAID,
                         (DECODE(N.CDTIPOOPER,V_TIPO12,
                          DECODE(IDTPNFCREDEB,V_TPNF2,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),1,2),'  '),
                          DECODE(IDTPNFCREDEB,V_TPNF4,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),3,2),'  '),
                          DECODE(IDTPNFCREDEB,V_TPNF3,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),5,2),'  '),
                          DECODE(IDTPNFCREDEB,V_TPNF1,NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),7,2),'  '), NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),1,2),'  '))))), NVL(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),'  '))) AS CDTIPOOPERTG,
                         NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER) AS DSTIPOOPER,
                         N.IDTPIJURNF,
                         DECODE(IDTPIJURNF, V_IDTPIJURNF, SUBSTR(NRINSJURNF,7,14) , NRINSJURNF) AS NRINSJURNF,
                         SUBSTR(NVL(NRNOTAFISC,LPAD('0',NVL(PF.NRTAMNUMNFUT,7),'0')),1,9) AS NRNOTAFISC,
                         SUBSTR(N.CDSERIE,1,4) AS CDSERIE,
                         N.DTEMISSAO,
                         N.CDFILIRECE,
                         SUBSTR(NVL(PROD.CDPRODINTE,PROD.CDARVPROD),1,10) CDPRODUTOTG,
                         I.QTITEMPROD,
                         I.VRUNITITEM,
                         I.VRDESCITEM,
                         I.IDTPNFCREDEB,
                         N.VRNOTAFISC,
                         N.IDENTRSAIDOP,
                         T.CDTIPOOPER AS TIPOOPER,
                         PF.CDEXFILIAL,
                         N.CDFILIAL, N.NRLANCTONF, I.NRSEQITPROD, N.CDFILIEMIT AS CDFILIALRE, N.DTENTRSAID AS DTNUMERNF,
                         N.CDEMPRESA, N.CDINSCESTA, V_IDENTRSAID AS IDTIPOOPERNF, PROD.CDPRODUTO, N.IDSTATUS,
                         N.DTCANCELANF, P.DSOBPARAMEMISRE, N.NRCPFCNPJNF, T.IDORIGDESTOP, I.CDALMOXARIFE AS CDALMOXITEM

                  FROM NOTAFISCAL N, ITEMPRODUTO I,  PRODUTO PROD,
                       TIPOOPERAC T, PARAMFILIAL PF, USR_CDEXPFITPOP U, PARAMEMISSAORE P,

                         (SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, TO_DATE('01/'||TO_CHAR(ADD_MONTHS(F.DTENTRSAID,1),'MM/YYYY')) AS DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES) <  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES) >=  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  = F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES IS NULL)) DATA

                  WHERE (N.CDFILIEMIT        = P_CDFILIAL)                             AND
                        (N.DTENTRSAID        = P_DTINICIAL)                            AND
                        (N.IDENTRSAIDOP      = V_IDENTRSAID)                           AND
                        (N.IDSTATUS          <> V_STATUSCANC)                          AND
                        (N.IDSISTEMA = V_IDSISDFS OR N.IDSISTEMA = V_IDSISEST          OR
                         N.IDSISTEMA = V_IDSISFAI OR N.IDSISTEMA IS NULL)              AND
                        ((N.IDGEROUTDOCU IS NULL) OR (N.IDGEROUTDOCU = V_IDTIPODADOA)) AND
                        (N.CDFILIAL          = I.CDFILIAL)                             AND
                        (N.NRLANCTONF        = I.NRLANCTONF)                           AND
                        (N.CDFILIAL          = PF.CDFILIAL)                            AND
                        (N.CDTIPOOPER        = T.CDTIPOOPER)                           AND
                        (N.IDENTRSAIDOP      = T.IDENTRSAIDOP)                         AND
                        (NVL(T.IDCOMPGERTG, 'F') = 'F')                                AND
                        (N.CDTIPOOPER        = U.CDTIPOOPER(+))                        AND
                        (N.IDENTRSAIDOP      = U.IDENTRSAIDOP(+))                      AND
                        (N.CDFILIEMIT        = U.CDFILIAL(+))                          AND
                        (I.CDPRODUTO         = PROD.CDPRODUTO)                         AND
                        (N.CDFILIAL          = DATA.CDFILIAL(+))                       AND
                        (N.NRLANCTONF        = DATA.NRLANCTONF(+))                     AND
                        (N.CDPARAMEMISRE     = P.CDPARAMEMISRE (+))
                  UNION ALL
                  SELECT PF.IDTIPODADOTG, N.CDTIPOOPER, '' AS CDALMOXARIFE, '' AS CDLOCALESTOQ,
                        (DECODE(N.IDENTRSAIDOP, NULL, NVL(NVL(CDEXFILIAL,N.CDFILIAL),'    '),
                         DECODE(IDTIPODADOTG, V_IDTIPODADOL,'    ', V_IDTIPODADOA,'    ', NVL(NVL(CDEXFILIAL,N.CDFILIAL),'    ')))) AS CDFILIALTG,
                         N.CDFILIEMIT,
                         NVL(SUBSTR(N.NRSEQCAPADOC,7,10),'    ') AS NRNUMRETG,
                         N.NRSEQCAPADOC AS NRNUMERNF,
                         DATA.DTENTRSAID,
                         NVL(SUBSTR(NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER),1,2),'  ') AS CDTIPOOPERTG,
                         NVL(U.CDEXTIPOOPER, T.CDEXTIPOOPER) AS DSTIPOOPER,
                         N.IDTPIJURNF,
                         DECODE(IDTPIJURNF, V_IDTPIJURNF, SUBSTR(NRINSJURNF,7,14) , NRINSJURNF) AS NRINSJURNF,
                         SUBSTR(NVL(NRNOTAFISC,LPAD('0',NVL(PF.NRTAMNUMNFUT,7),'0')),1,9) AS NRNOTAFISC,
                         SUBSTR(N.CDSERIE,1,4) AS CDSERIE,
                         N.DTEMISSAO,
                         N.CDFILIRECE,
                         V_STRING AS CDPRODUTOTG,
                         V_VALOR AS QTITEMPROD,
                         V_VALOR AS VRUNITITEM,
                         V_VALOR AS VRDESCITEM,
                         V_STRING AS IDTPNFCREDEB,
                         N.VRNOTAFISC,
                         N.IDENTRSAIDOP,
                         T.CDTIPOOPER AS TIPOOPER,
                         PF.CDEXFILIAL,
                         N.CDFILIAL, N.NRLANCTONF, V_STRING AS NRSEQITPROD, N.CDFILIEMIT AS CDFILIALRE, N.DTENTRSAID AS DTNUMERNF,
                         N.CDEMPRESA, N.CDINSCESTA, V_IDENTRSAID AS IDTIPOOPERNF, '' AS CDPRODUTO, N.IDSTATUS,
                         N.DTCANCELANF, P.DSOBPARAMEMISRE, N.NRCPFCNPJNF, T.IDORIGDESTOP, '' AS CDALMOXITEM
                  FROM NOTAFISCAL N, TIPOOPERAC T, PARAMFILIAL PF, USR_CDEXPFITPOP U, PARAMEMISSAORE P,
                         (SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, TO_DATE('01/'||TO_CHAR(ADD_MONTHS(F.DTENTRSAID,1),'MM/YYYY')) AS DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  =  F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES) <  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  =  F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES) >=  SUBSTR(TO_CHAR(F.DTENTRSAID,'DDMMYYYY'), 1, 2)
                           UNION ALL
                          SELECT DISTINCT F.CDFILIAL, F.NRLANCTONF, F.DTENTRSAID
                            FROM NOTAFISCAL F,
                                 (SELECT NVL(SUBSTR(D.DTFECMES,1,2),P.NRDIAFECHMES) DTDIAFECMES, P.CDFILIAL, D.DTFECMES,
                                         SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) DT, P.NRDIAFECHMES
                                    FROM PARAMFILIAL P , (SELECT D.DTFECMES, D.CDFILIAL
                                                            FROM DIAFECMES D
                                                           WHERE D.CDFILIAL = P_CDFILIAL
                                                             AND (SUBSTR(TO_CHAR(NVL(D.DTFECMES,P_DTINICIAL),'DDMMYYYY'),3,6) = SUBSTR(TO_CHAR(P_DTINICIAL,'DDMMYYYY'),3,6))) D
                                    WHERE P.CDFILIAL = P_CDFILIAL
                                      AND P.CDFILIAL = D.CDFILIAL(+)
                                 ) T
                           WHERE (F.CDFILIEMIT   =  P_CDFILIAL)   AND
                                 (F.DTENTRSAID   =  P_DTINICIAL)  AND
                                 (T.CDFILIAL(+)  =  F.CDFILIEMIT)  AND
                                 (T.DTDIAFECMES IS NULL)) DATA

                  WHERE (N.CDFILIEMIT        = P_CDFILIAL)                         AND
                        (N.DTENTRSAID        = P_DTINICIAL)                        AND
                        (N.IDENTRSAIDOP      = V_IDENTRSAID)                       AND
                        (N.IDSTATUS          = V_STATUSCANC)                       AND
                        (N.IDSISTEMA = V_IDSISDFS OR N.IDSISTEMA    = V_IDSISEST   OR
                         N.IDSISTEMA    = V_IDSISFAI OR N.IDSISTEMA IS NULL)       AND
                        (N.IDGEROUTDOCU IS NULL OR N.IDGEROUTDOCU = V_IDTIPODADOA) AND
                        (N.CDFILIAL          = PF.CDFILIAL)                        AND
                        (N.CDTIPOOPER        = T.CDTIPOOPER)                       AND
                        (N.IDENTRSAIDOP      = T.IDENTRSAIDOP)                     AND
                        (NVL(T.IDCOMPGERTG, 'F') = 'F')                            AND
                        (N.CDTIPOOPER        = U.CDTIPOOPER(+))                    AND
                        (N.IDENTRSAIDOP      = U.IDENTRSAIDOP(+))                  AND
                        (N.CDFILIEMIT        = U.CDFILIAL(+))                      AND
                        (N.CDFILIAL          = DATA.CDFILIAL(+))                   AND
                        (N.NRLANCTONF        = DATA.NRLANCTONF(+))                 AND
                        (N.CDPARAMEMISRE    = P.CDPARAMEMISRE (+))) LOOP

         V_VRSOMANUMNFS := 0;

         /* RETORNA A SOMA DO NMERO DAS NF'S DE SAIDA*/
         SELECT SUM(NVL(TO_NUMBER(A.NRNOTAFISC),0))
           INTO V_VRSOMANUMNFS
           FROM (SELECT DISTINCT NRNOTAFISC
                   FROM NOTAFISCAL N, ITEMPRODUTO I, TIPOOPERAC T
                  WHERE N.CDFILIEMIT = P_CDFILIAL
                    AND N.IDENTRSAIDOP = V_IDENTRSAID
                    AND N.CDTIPOOPER = T.CDTIPOOPER
                    AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                    AND N.NRSEQCAPADOC = C_SAIDA.NRNUMERNF
                    AND NVL(T.IDCOMPGERTG, 'F') = 'F'
                    AND N.IDSTATUS <> V_STATUSCANC
                    AND N.DTENTRSAID = P_DTINICIAL
                    AND I.CDFILIAL = N.CDFILIAL
                    AND I.NRLANCTONF = N.NRLANCTONF
                    AND NVL(I.CDALMOXARIFE, ' ') = NVL(C_SAIDA.CDALMOXITEM, ' ')
                    AND (N.IDSISTEMA = V_IDSISDFS OR
                         N.IDSISTEMA = V_IDSISFAI OR
                         N.IDSISTEMA = V_IDSISFAS OR
                         N.IDSISTEMA = V_IDSISFAC OR
                         N.IDSISTEMA IS NULL)) A;

         /* INFORMAES FINANCEIRAS */
         SELECT MIN(DTATUAVENREC), MIN(NRSEQVENREC),
                MIN(NRPARCELAREC), MIN(C.CDFILIBOLREC),
                MIN(B.NRLANBOLREC), MIN(B.CDREDUCONT),
                MIN(DECODE(CDTPBAIXAREC, V_TIPO2, LTRIM(SUBSTR(LPAD(CDDEPIDENREC, 30, ' '), 10, 21)), CDCARTCOBBOL||REPLACE(CDNOSNUMREC,'-','')))
         INTO V_DTATUAVENREC, V_NRSEQVENREC, V_NRPARCELAREC, V_CDFILIBREC, V_NRLANBOLREC,
              V_CDREDUCONT, V_CDNOSNUMREC
         FROM CONTARECEBER C, BOLETRECEBER B, CONTCORR E
         WHERE C.CDFILIAL      = C_SAIDA.CDFILIAL   AND
               C.NRLANCTONF    = C_SAIDA.NRLANCTONF AND
               C.CDFILIBOLREC  = B.CDFILIAL(+)      AND
               C.NRLANBOLREC   = B.NRLANBOLREC(+)   AND
               E.CDREDUCONT(+) = B.CDREDUCONT;

         SELECT MIN(CDENCARGO),
                SUM(DECODE(CDENCARGO, V_TIPO1, VRITEMENCA, V_TIPO2, VRITEMENCA, V_TIPO3, VRITEMENCA,0)),
                SUM(DECODE(CDENCARGO, V_TIPO4, VRITEMENCA, 0)),
                SUM(DECODE(CDENCARGO, V_TIPO5, VRITEMENCA, 0))
         INTO V_CDENCARGO, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI
         FROM ITEMENCARGO
         WHERE CDFILIAL    =  C_SAIDA.CDFILIAL   AND
               NRLANCTONF  =  C_SAIDA.NRLANCTONF;

         SELECT MAX(CDIMPOSTO), SUM(VRTOTIMPONF)
         INTO V_CDIMPOSTOT, V_VRIRRETIDO
         FROM  IMPOSNFTOT
         WHERE CDFILIAL   = C_SAIDA.CDFILIAL   AND
               NRLANCTONF = C_SAIDA.NRLANCTONF AND
               CDIMPOSTO  = V_TIPO20;

         SELECT MAX(CDIMPOSTO), MAX(NRITPROIMPOS) ,
                SUM(VRIMPOSTOIT)
         INTO V_CDIMPOSTOIT, V_NRITPROIMPOS, V_VRIPIPROD
         FROM ITEMPROIMPOS
         WHERE CDFILIAL    = C_SAIDA.CDFILIAL    AND
               NRLANCTONF  = C_SAIDA.NRLANCTONF  AND
               NRSEQITPROD = C_SAIDA.NRSEQITPROD AND
               CDIMPOSTO   = V_TIPO10;

         SELECT MAX(NA.CDFILIEMIT), MAX(SUBSTR(NA.NRNOTAFISC,1,9)),
                MAX(FIS.NRSEQUITNOTA), MAX(NVL(NA.CDSERIE, NA.CDSERIEENTR)), MAX(NA.NRINSJURNF)
         INTO V_CDFILIORIGDE, V_NRNOTAORIGDE, V_NRSEQUITNOTA,
              V_CDSERORIGDE, V_NRIJURORIGDE
         FROM NOTAFISCAL NA, ITEMNOTAFISC FIS
         WHERE FIS.CDFILIAL     = C_SAIDA.CDFILIAL   AND
               FIS.NRLANCTONF   = C_SAIDA.NRLANCTONF AND
               FIS.CDFILIALIT   = NA.CDFILIAL        AND
               FIS.NRLANCTONFIT = NA.NRLANCTONF;

          IF C_SAIDA.IDSTATUS = 'C' THEN
             V_IDSTCANCNF := 'S';
          ELSE
             V_IDSTCANCNF := 'N';
          END IF;

          V_NRINSJURNFTG := '';
          V_CDINSCESTA   := '';

          IF C_SAIDA.IDORIGDESTOP = 'L' THEN

             SELECT MAX(NRINSJURFILI), MAX(CDINSCESTA)
               INTO V_NRINSJURNFTG, V_CDINSCESTA
               FROM FILIAL
              WHERE CDFILIAL = C_SAIDA.CDFILIEMIT;
          ELSE
             V_NRINSJURNFTG := C_SAIDA.NRINSJURNF;
             V_CDINSCESTA := C_SAIDA.CDINSCESTA;
          END IF;

   /*Insere as NF's de SAIDA do TG normal*/
         INSERT INTO EXPORTACAOTG
            (CDEMPRESATG, CDFILIALTG, NRNUMERORETG, DTCONTABILTG, VRSOMNUMDCTG,CDTIPOOPERTG, IDTPIJURNFTG, NRINSJURNFTG, NRNOTAFISCTG, CDSERIEENTTG, DTEMISSAOTG, DTATVENPAGTG,
             CDFILIRECETG, VRDESPESATG, VRDESCONTOTG, VRICMSRETITG, VRIRRETIDOTG, NRINIMAQRETG, NRFIMMAQRETG, NRTOTMAQRETG, CDPRODUTOTG, QTITEMPRODTG, VRUNITITEMTG, VRDESCITEMTG,
             VRIPIPRODTG, VRNOTAFISCTG, CDFILIEMITTG, IDALTERADATG, CDFIORIGDETG, CDSERORIDETG, NRIJURORIGDE, CDCFISCOPTG, NRLANBOLETTG, VRDOTACAOTG, VRIMPINSSTG, VRIMPISSTG,
             NRMAQREGTG, NRREDUCAOTG, VLRMAQRETG, VLRCANCANTG, CROTG, DTRECEBIMTG, CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO, IDENTRSAIDOP, CDTIPOOPER, DTNUMERNF, IDENTRSAID,
             IDTIPOOPERNF, NRSEQVENPAG, NRPARCELAPAG, NRLANBOLPAG, CDREDUCONT, CDENCARGO, CDIMPOSTOT, CDIMPOSTO, NRITPROIMPOS, NRSEQUITNOTA, CDEMPRESA, CDINSCESTA, NRSEQVENREC,
             NRPARCELAREC, NRLANBOLREC, IDSTCANCNF, DTCANCNFTG, CDFILIBPAG, CDFILIBREC, CDFILIALRE, NRNUMERNF, DTMOVIEXPTG, IDTIPOEXPTG,
             DSOBSERVRETG, NRCPFCNPJNFTG)
         VALUES
            ('08', C_SAIDA.CDFILIALTG, C_SAIDA.NRNUMRETG, C_SAIDA.DTENTRSAID, V_VRSOMANUMNFS, C_SAIDA.CDTIPOOPERTG,
             C_SAIDA.IDTPIJURNF, V_NRINSJURNFTG, C_SAIDA.NRNOTAFISC, C_SAIDA.CDSERIE, C_SAIDA.DTEMISSAO, ''/*DTATUAVENPAG*/,
             C_SAIDA.CDFILIRECE, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI, V_VRIRRETIDO, '0000000000' /*VRIMAQRE*/,
             '0000000000' /*VRFMAQRE*/, '0000000000' /*VRAMAQRE*/, C_SAIDA.CDPRODUTOTG, C_SAIDA.QTITEMPROD, C_SAIDA.VRUNITITEM, C_SAIDA.VRDESCITEM,
             V_VRIPIPROD, C_SAIDA.VRNOTAFISC, C_SAIDA.CDFILIEMIT, 'S' /*IDALTERADA*/, V_NRNOTAORIGDE, V_CDSERORIGDE,
             V_NRIJURORIGDE, '' /*CDFISCOPTG*/, V_CDNOSNUMREC, 0 /*VRDOTACAO*/, 0/*VRIMPINSSTG*/, 0 /*VRIMPISSTG*/,
             '' /*NRMAQREGTG*/, '' /*NRREDUCAOTG*/, 0 /*VLRMAQRETG*/, 0 /*VLRCANCANTG*/, '' /*CROTG*/, ''/*DTRECEBIMENTO*/, C_SAIDA.CDFILIAL,
             C_SAIDA.NRLANCTONF, C_SAIDA.NRSEQITPROD, C_SAIDA.CDPRODUTO, C_SAIDA.IDENTRSAIDOP, C_SAIDA.TIPOOPER, C_SAIDA.DTNUMERNF, C_SAIDA.IDENTRSAIDOP,
             C_SAIDA.IDTIPOOPERNF, ''/*NRSEQVENPAG*/, '' /*NRPARCELAPAG*/, ''/*NRLANBOLPAG*/, V_CDREDUCONT, V_CDENCARGO, V_CDIMPOSTOT,
             V_CDIMPOSTOIT, V_NRITPROIMPOS, V_NRSEQUITNOTA, C_SAIDA.CDEMPRESA, V_CDINSCESTA, V_NRSEQVENREC, V_NRPARCELAREC,
             V_NRLANBOLREC, V_IDSTCANCNF, C_SAIDA.DTCANCELANF, ''/*CDFILIBPAG*/, V_CDFILIBREC, C_SAIDA.CDFILIALRE, C_SAIDA.NRNUMERNF, C_SAIDA.DTENTRSAID, 'F',
             C_SAIDA.DSOBPARAMEMISRE, C_SAIDA.NRCPFCNPJNF);
      END LOOP;
   ELSE
      /* EXPORTAO DO TG CENTRALIZADO*/

      /* APAGA OS REGISTROS DA TABELA ANTES DE EXPORTAR (CHAVE DE EXCLUSAO : EMPRESA, FILIAL DO RE, NMERO DO RE, DATA DE MOVIMENTACAO*/
      DELETE FROM EXPORTACAOTG
      WHERE EXISTS
         (SELECT F.CDFILIAL
          FROM NUMERORNF RE,
             (SELECT CDFILIAL FROM FILIAL FL
              WHERE NVL(CDFILIFISC,CDFILIAL) = P_CDFILIAL) F
          WHERE CDEMPRESATG  = V_TIPO8      AND
                RE.CDFILIAL  = F.CDFILIAL   AND
                RE.DTNUMERNF = P_DTINICIAL  AND
                CDFILIALRE   =  RE.CDFILIAL AND
                NRNUMERORETG = (V_TPNF8||SUBSTR(NRNUMERNF,8,10)) AND
                DTMOVIEXPTG  = P_DTINICIAL);

      FOR C_SAIDACENTR IN (SELECT PF.IDTIPODADOTG, N.CDTIPOOPER, I.CDALMOXARIFE, I.CDLOCALESTOQ,
                             RPAD(DECODE(N.IDENTRSAIDOP, NULL, NVL(CDFILIEMIT, V_ESPACO),
                              DECODE(IDTIPODADOTG, V_IDTIPODADOL, NVL(SUBSTR(I.CDLOCALESTOQ,
                              DECODE(LENGTH(I.CDLOCALESTOQ),6,3,5,2,1),4), V_ESPACO), V_IDTIPODADOA, NVL(SUBSTR(I.CDALMOXARIFE,
                              DECODE(LENGTH(I.CDALMOXARIFE),6,3,5,2,1),4), V_ESPACO), NVL(CDFILIEMIT, V_ESPACO))), 4, V_ESPACO) AS CDFILIALTG,
                              N.CDFILIAL,
                              N.CDEMPRESA,
                              N.CDFILIEMIT,
                              RPAD(NVL(V_TPNF8||NVL(SUBSTR(N.NRSEQCAPADOC,8,10),V_ESPACO),'100'),4, V_ESPACO)  AS NRNUMRETG,
                              N.NRSEQCAPADOC AS NRNUMERNF,
                              N.DTENTRSAID,
                              T.CDEXTIPOOPER AS DSTIPOOPER,
                              N.IDTPIJURNF,
                              DECODE(IDTPIJURNF, V_IDTPIJURNF, SUBSTR(NRINSJURNF,7,14) , NRINSJURNF) AS NRINSJURNF,
                              SUBSTR(NVL(NRNOTAFISC,LPAD('0',NVL(PF.NRTAMNUMNFUT,7),'0')),1,9) AS NRNOTAFISC,
                              NVL(S.CDEXPSERIENF, N.CDSERIE) AS CDSERIE,
                              N.DTEMISSAO,
                              N.CDFILIRECE,
                              SUBSTR(NVL(PROD.CDPRODINTE,PROD.CDARVPROD),1,10) CDPRODUTOTG,
                              I.QTITEMPROD,
                              I.VRUNITITEM,
                              I.VRDESCITEM,
                              ABS(N.VRNOTAFISC) VRNOTAFISC,
                              N.IDENTRSAIDOP,
                              N.NRLANCTONF, I.NRSEQITPROD, P_CDFILIAL AS CDFILIALRE, N.DTAPROVACAO AS DTNUMERNF,
                              N.CDINSCESTA, V_IDENTRSAID AS IDTIPOOPERNF, PROD.CDPRODUTO, N.IDSTATUS, N.DTCANCELANF,
                              N.DTAPROVACAO, P.DSOBPARAMEMISRE, N.NRCPFCNPJNF, I.CDALMOXARIFE AS CDALMOXITEM

                       FROM NOTAFISCAL N, ITEMPRODUTO I, PRODUTO PROD, TIPOOPERAC  T,
                            PARAMFILIAL PF, SERIENF S, PARAMEMISSAORE P
                       WHERE N.CDFILIAL     = I.CDFILIAL                            AND
                             N.NRLANCTONF   = I.NRLANCTONF                          AND
                             N.CDFILIEMIT   = PF.CDFILIAL                           AND
                             N.CDTIPOOPER   = T.CDTIPOOPER                          AND
                             N.IDENTRSAIDOP = T.IDENTRSAIDOP                        AND
                             T.IDCOMPGERTG  = 'C'                                   AND
                             I.CDPRODUTO    = PROD.CDPRODUTO                        AND
                             N.CDEMPRESA    = S.CDEMPRESA                           AND
                             N.CDINSCESTA   = S.CDINSCESTA                          AND
                             N.CDINSCMUNI   = S.CDINSCMUNI                          AND
                             N.CDSERIE      = S.CDSERIE                             AND
                             N.IDENTRSAIDOP = V_IDENTRSAID                          AND
                             (IDSTATUS = V_IDTIPODADOA OR IDSTATUS = V_STATUSEMI)   AND
                             (N.DTAPROVACAO =  P_DTINICIAL)                         AND
                             (N.IDSISTEMA = V_IDSISDFS                              OR
                              N.IDSISTEMA = V_IDSISEST                              OR
                              N.IDSISTEMA = V_IDSISPDV                              OR
                              N.IDSISTEMA = V_IDSISFAS                              OR
                              N.IDSISTEMA = V_IDSISFAI OR N.IDSISTEMA IS NULL)      AND
                              N.CDPARAMEMISRE = P.CDPARAMEMISRE (+)                 AND
                              EXISTS (SELECT CDFILIAL
                                        FROM FILIAL FL
                                       WHERE NVL(CDFILIFISC,CDFILIAL) = P_CDFILIAL
                                         AND N.CDFILIEMIT = FL.CDFILIAL)
                       UNION ALL
                       SELECT PF.IDTIPODADOTG, N.CDTIPOOPER, V_STRING AS CDALMOXARIFE, V_STRING AS CDLOCALESTOQ,
                             RPAD(DECODE(N.IDENTRSAIDOP, NULL, NVL(CDFILIEMIT, V_ESPACO),
                              DECODE(IDTIPODADOTG, V_IDTIPODADOL, NVL(SUBSTR(I.CDLOCALESTOQ,
                              DECODE(LENGTH(I.CDLOCALESTOQ),6,3,5,2,1),4), V_ESPACO), V_IDTIPODADOA, NVL(SUBSTR(I.CDALMOXARIFE,
                              DECODE(LENGTH(I.CDALMOXARIFE),6,3,5,2,1),4), V_ESPACO) ,NVL(CDFILIEMIT, V_ESPACO))), 4, V_ESPACO) AS CDFILIALTG,
                              N.CDFILIAL,
                              N.CDEMPRESA,
                              N.CDFILIEMIT,
                              RPAD(NVL(V_TPNF8||NVL(SUBSTR(N.NRSEQCAPADOC,8,10), V_ESPACO),'100'),4, V_ESPACO)  AS NRNUMRETG,
                              N.NRSEQCAPADOC AS NRNUMERNF,
                              N.DTENTRSAID,
                              T.CDEXTIPOOPER AS DSTIPOOPER,
                              N.IDTPIJURNF,
                              DECODE(IDTPIJURNF, V_IDTPIJURNF, SUBSTR(NRINSJURNF,7,14) , NRINSJURNF) AS NRINSJURNF,
                              SUBSTR(NVL(NRNOTAFISC,LPAD('0',NVL(PF.NRTAMNUMNFUT,7),'0')),1,9) AS NRNOTAFISC,
                              NVL(S.CDEXPSERIENF, N.CDSERIE) AS CDSERIE,
                              N.DTEMISSAO,
                              N.CDFILIRECE,
                              SUBSTR(NVL(PROD.CDPRODINTE,PROD.CDARVPROD),1,10) CDPRODUTOTG,
                              V_VALOR AS QTITEMPROD,
                              V_VALOR AS VRUNITITEM,
                              V_VALOR AS VRDESCITEM,
                              ABS(N.VRNOTAFISC) VRNOTAFISC,
                              N.IDENTRSAIDOP,
                              N.NRLANCTONF, I.NRSEQITPROD, P_CDFILIAL AS CDFILIALRE, N.DTAPROVACAO AS DTNUMERNF,
                              N.CDINSCESTA, V_IDENTRSAID AS IDTIPOOPERNF, PROD.CDPRODUTO, N.IDSTATUS, N.DTCANCELANF,
                              N.DTAPROVACAO, P.DSOBPARAMEMISRE, N.NRCPFCNPJNF, I.CDALMOXARIFE AS CDALMOXITEM

                       FROM NOTAFISCAL N, ITEMPRODUTO I, PRODUTO PROD, TIPOOPERAC  T, PARAMFILIAL PF, SERIENF S,
                            PARAMEMISSAORE P
                       WHERE N.CDFILIAL     = I.CDFILIAL        AND
                             N.NRLANCTONF   = I.NRLANCTONF      AND
                             N.CDFILIEMIT   = PF.CDFILIAL       AND
                             N.CDTIPOOPER   = T.CDTIPOOPER      AND
                             N.IDENTRSAIDOP = T.IDENTRSAIDOP    AND
                             T.IDCOMPGERTG  = 'C'               AND
                             I.CDPRODUTO    = PROD.CDPRODUTO    AND
                             N.CDEMPRESA    = S.CDEMPRESA       AND
                             N.CDINSCESTA   = S.CDINSCESTA      AND
                             N.CDINSCMUNI   = S.CDINSCMUNI      AND
                             N.CDSERIE      = S.CDSERIE         AND
                             N.IDENTRSAIDOP = V_IDENTRSAID      AND
                             (IDSTATUS      = V_STATUSCANC)     AND
                             (N.DTAPROVACAO =  P_DTINICIAL)     AND
                             (N.IDSISTEMA = V_IDSISDFS          OR
                              N.IDSISTEMA = V_IDSISEST          OR
                              N.IDSISTEMA = V_IDSISPDV          OR
                              N.IDSISTEMA = V_IDSISFAS          OR
                              N.IDSISTEMA = V_IDSISFAI          OR
                              N.IDSISTEMA IS NULL)              AND
                              N.CDPARAMEMISRE = P.CDPARAMEMISRE (+)                 AND
                              EXISTS (SELECT CDFILIAL
                                        FROM FILIAL FL
                                       WHERE NVL(CDFILIFISC,CDFILIAL) = P_CDFILIAL
                                         AND N.CDFILIEMIT = FL.CDFILIAL)) LOOP

         V_VRSOMANUMNF := 0;

         SELECT SUM(NVL(TO_NUMBER(A.NRNOTAFISC),0)) AS VRSOMANUMNF
           INTO V_VRSOMANUMNF
           FROM (SELECT DISTINCT NRNOTAFISC
                   FROM NOTAFISCAL N, ITEMPRODUTO I, TIPOOPERAC T
                  WHERE (N.CDFILIEMIT  = C_SAIDACENTR.CDFILIEMIT) AND
                        (N.DTENTRSAID  = C_SAIDACENTR.DTENTRSAID) AND
                        (N.IDENTRSAIDOP = V_IDENTRSAID)           AND
                        (N.IDENTRSAIDOP = T.IDENTRSAIDOP)         AND
                        (N.CDTIPOOPER   = T.CDTIPOOPER)           AND
                        (T.IDCOMPGERTG  = 'C')                    AND
                        (N.IDSTATUS  = V_IDTIPODADOA              OR
                         N.IDSTATUS  = V_STATUSEMI )              AND
                        (N.DTAPROVACAO =  P_DTINICIAL)            AND
                        I.CDFILIAL = N.CDFILIAL                   AND
                        I.NRLANCTONF = N.NRLANCTONF               AND
                        NVL(I.CDALMOXARIFE, ' ') = NVL(C_SAIDACENTR.CDALMOXITEM, ' ') AND
                        (N.IDSISTEMA = V_IDSISDFS                 OR
                         N.IDSISTEMA = V_IDSISFAI                 OR
                         N.IDSISTEMA = V_IDSISFAS                 OR
                         N.IDSISTEMA = V_IDSISPDV                 OR
                         N.IDSISTEMA IS NULL)) A;

         SELECT MIN(DTATUAVENREC), MIN(NRSEQVENREC) ,
                MIN(NRPARCELAREC), MIN(C.CDFILIBOLREC),
                MIN(B.NRLANBOLREC), MIN(B.CDREDUCONT),
                MIN(DECODE(CDTPBAIXAREC, V_TIPO2, LTRIM(SUBSTR(LPAD(CDDEPIDENREC, 30, V_ESPACO), 10, 21)), CDCARTCOBBOL||REPLACE(CDNOSNUMREC, V_TRACO, V_STRING)))
         INTO V_DTATUAVENREC, V_NRSEQVENREC, V_NRPARCELAREC, V_CDFILIBREC, V_NRLANBOLREC,
              V_CDREDUCONT,  V_CDNOSNUMREC
         FROM CONTARECEBER C, BOLETRECEBER B, CONTCORR E
         WHERE C.CDFILIAL      = C_SAIDACENTR.CDFILIAL   AND
               C.NRLANCTONF    = C_SAIDACENTR.NRLANCTONF AND
               C.CDFILIBOLREC  = B.CDFILIAL              AND
               C.NRLANBOLREC   = B.NRLANBOLREC           AND
               E.CDREDUCONT    = B.CDREDUCONT ;

         SELECT MIN(CDENCARGO),
                SUM(DECODE(CDENCARGO, V_TIPO1, VRITEMENCA, V_TIPO2, VRITEMENCA, V_TIPO3, VRITEMENCA,0)),
                SUM(DECODE(CDENCARGO, V_TIPO4, VRITEMENCA,0)),
                SUM(DECODE(CDENCARGO, V_TIPO5, VRITEMENCA,0))
         INTO V_CDENCARGO, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI
         FROM ITEMENCARGO
         WHERE  CDFILIAL   = C_SAIDACENTR.CDFILIAL AND
                NRLANCTONF = C_SAIDACENTR.NRLANCTONF;

         SELECT MAX(CDIMPOSTO), SUM(VRTOTIMPONF)
         INTO V_CDIMPOSTOT, V_VRIRRETIDO
         FROM IMPOSNFTOT
         WHERE CDFILIAL   = C_SAIDACENTR.CDFILIAL    AND
               NRLANCTONF = C_SAIDACENTR.NRLANCTONF  AND
               CDIMPOSTO  = V_TIPO20;

         SELECT MAX(CDIMPOSTO), MAX(NRITPROIMPOS),
                SUM(VRIMPOSTOIT)
         INTO V_CDIMPOSTOIT, V_NRITPROIMPOS, V_VRIPIPROD
         FROM ITEMPROIMPOS
         WHERE CDFILIAL    = C_SAIDACENTR.CDFILIAL     AND
               NRLANCTONF  = C_SAIDACENTR.NRLANCTONF   AND
               NRSEQITPROD = C_SAIDACENTR.NRSEQITPROD  AND
               CDIMPOSTO   = V_CDIMPOSTOIT;

         SELECT MAX(NA.CDFILIEMIT), MAX(SUBSTR(NA.NRNOTAFISC,1,9)),
                MAX(FIS.NRSEQUITNOTA), MAX(NVL(NA.CDSERIE, NA.CDSERIEENTR)), MAX(NA.NRINSJURNF)
         INTO V_CDFILIORIGDE, V_NRNOTAORIGDE, V_NRSEQUITNOTA,
              V_CDSERORIGDE, V_NRIJURORIGDE
         FROM NOTAFISCAL NA, ITEMNOTAFISC FIS
         WHERE FIS.CDFILIAL     = C_SAIDACENTR.CDFILIAL   AND
               FIS.NRLANCTONF   = C_SAIDACENTR.NRLANCTONF AND
               FIS.CDFILIALIT   = NA.CDFILIAL             AND
               FIS.NRLANCTONFIT = NA.NRLANCTONF;


          IF C_SAIDACENTR.IDSTATUS = 'C' THEN
             V_IDSTCANCNF := 'S';
          ELSE
             V_IDSTCANCNF := 'N';
          END IF;

         /*INSERE AS NF'S DE SAIDA DO TG CENTRALIZADO*/

         INSERT INTO EXPORTACAOTG
            (CDEMPRESATG, CDFILIALTG, NRNUMERORETG, DTCONTABILTG, VRSOMNUMDCTG,CDTIPOOPERTG, IDTPIJURNFTG, NRINSJURNFTG, NRNOTAFISCTG, CDSERIEENTTG, DTEMISSAOTG, DTATVENPAGTG,
             CDFILIRECETG, VRDESPESATG, VRDESCONTOTG, VRICMSRETITG, VRIRRETIDOTG, NRINIMAQRETG, NRFIMMAQRETG, NRTOTMAQRETG, CDPRODUTOTG, QTITEMPRODTG, VRUNITITEMTG, VRDESCITEMTG,
             VRIPIPRODTG, VRNOTAFISCTG, CDFILIEMITTG, IDALTERADATG, CDFIORIGDETG, CDSERORIDETG, NRIJURORIGDE, CDCFISCOPTG, NRLANBOLETTG, VRDOTACAOTG, VRIMPINSSTG, VRIMPISSTG,
             NRMAQREGTG, NRREDUCAOTG, VLRMAQRETG, VLRCANCANTG, CROTG, DTRECEBIMTG, CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO, IDENTRSAIDOP, CDTIPOOPER, DTNUMERNF, IDENTRSAID,
             IDTIPOOPERNF, NRSEQVENPAG, NRPARCELAPAG, NRLANBOLPAG, CDREDUCONT, CDENCARGO, CDIMPOSTOT, CDIMPOSTO, NRITPROIMPOS, NRSEQUITNOTA, CDEMPRESA, CDINSCESTA, NRSEQVENREC,
             NRPARCELAREC, NRLANBOLREC, IDSTCANCNF, DTCANCNFTG, CDFILIBPAG, CDFILIBREC, CDFILIALRE, NRNUMERNF, DTMOVIEXPTG, IDTIPOEXPTG,
             DSOBSERVRETG, NRCPFCNPJNFTG)
         VALUES
            (C_SAIDACENTR.CDEMPRESA, C_SAIDACENTR.CDFILIALTG, C_SAIDACENTR.NRNUMRETG, C_SAIDACENTR.DTENTRSAID, V_VRSOMANUMNF, C_SAIDACENTR.DSTIPOOPER, C_SAIDACENTR.IDTPIJURNF, C_SAIDACENTR.NRINSJURNF,
             C_SAIDACENTR.NRNOTAFISC, C_SAIDACENTR.CDSERIE, C_SAIDACENTR.DTEMISSAO, V_DTATUAVENREC, C_SAIDACENTR.CDFILIRECE, V_VRDESPESA, V_VRDESCONTO, V_VRICMSRETI, V_VRIRRETIDO, '0000000000' /*VRIMAQRE*/,
             '0000000000' /*VRFMAQRE*/, '0000000000' /*VRAMAQRE*/, C_SAIDACENTR.CDPRODUTOTG, C_SAIDACENTR.QTITEMPROD, C_SAIDACENTR.VRUNITITEM, C_SAIDACENTR.VRDESCITEM,
             V_VRIPIPROD, C_SAIDACENTR.VRNOTAFISC, C_SAIDACENTR.CDFILIEMIT, 'S' /*IDALTERADA*/, V_NRNOTAORIGDE, V_CDSERORIGDE, V_NRIJURORIGDE, '' /*CDFISCOPTG*/,
             V_CDNOSNUMREC, 0 /*VRDOTACAO*/, 0/*VRIMPINSSTG*/, 0 /*VRIMPISSTG*/, '' /*NRMAQREGTG*/, '' /*NRREDUCAOTG*/, 0 /*VLRMAQRETG*/, 0 /*VLRCANCANTG*/, '' /*CROTG*/, ''/*DTRECEBIMENTO*/,
             C_SAIDACENTR.CDFILIAL, C_SAIDACENTR.NRLANCTONF, C_SAIDACENTR.NRSEQITPROD, C_SAIDACENTR.CDPRODUTO, C_SAIDACENTR.IDENTRSAIDOP, C_SAIDACENTR.CDTIPOOPER, C_SAIDACENTR.DTNUMERNF,
             C_SAIDACENTR.IDENTRSAIDOP, C_SAIDACENTR.IDTIPOOPERNF, ''/*NRSEQVENPAG*/, '' /*NRPARCELAPAG*/, ''/*NRLANBOLPAG*/, V_CDREDUCONT, V_CDENCARGO, V_CDIMPOSTOT,
             V_CDIMPOSTOIT, V_NRITPROIMPOS, V_NRSEQUITNOTA, C_SAIDACENTR.CDEMPRESA, C_SAIDACENTR.CDINSCESTA, V_NRSEQVENREC, V_NRPARCELAREC, V_NRLANBOLREC, V_IDSTCANCNF,
             C_SAIDACENTR.DTCANCELANF, ''/*CDFILIBPAG*/, V_CDFILIBREC, C_SAIDACENTR.CDFILIALRE, C_SAIDACENTR.NRNUMERNF, C_SAIDACENTR.DTAPROVACAO, 'C',
             C_SAIDACENTR.DSOBPARAMEMISRE, C_SAIDACENTR.NRCPFCNPJNF);
      END LOOP;
   END IF;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_TABELA_TG','5.50.XXX'); END;
/

